clear
close all

% image et FFT(image)
I=imread('/Users/marcel/Documents/MATLAB/0-images-exemples/trees.jpg');
I=rgb2gray(I);
I=double(I)/255.;
dim=size(I); dimx=dim(1); dimy=dim(2);

fx=((0:dimx-1)-dimx/2)/dimx;
fy=((0:dimy-1)-dimy/2)/dimy;

Ichap=fft2(I);
Ichapmod=abs(fftshift(Ichap));
rr=10; hh=fspecial('disk',rr); hh=hh/max(max(hh));

% filtrage passe-bas circulaire
figure(1), colormap('gray')

subplot(3,2,1), imagesc(I), colorbar, axis('square')
title('img'), xlabel('x'), ylabel('y')

subplot(3,2,2), imagesc(fx,fy,Ichapmod.^.1), colorbar, axis('square')
title('|TF(img)|^{0.1}'), xlabel('f_x'), ylabel('f_y')

hchap=zeros(dimx,dimy);
hchap(dimx/2+1-rr:dimx/2+1+rr,dimy/2+1-rr:dimy/2+1+rr)=hh;

subplot(3,2,4), imagesc(fx,fy,hchap), colorbar, axis('square')
title('|TF(passe-bas circ.)|'), xlabel('f_x'), ylabel('f_y')

hchap=fftshift(hchap);

Ichapfilt=hchap.*Ichap;
Ichapfiltmod=abs(fftshift(Ichapfilt));

subplot(3,2,6),imagesc(fx,fy,Ichapfiltmod.^.1), colorbar, axis('square')
title('|TF(img filt.)|^{0.1}'), xlabel('f_x'), ylabel('f_y')

Ifilt=ifft2(Ichapfilt);
subplot(3,2,5), imagesc(real(Ifilt)), colorbar, axis('square')
title('img filtre'), xlabel('x'), ylabel('y')

% filtrage passe-haut circulaire
figure(2), colormap('gray')

subplot(3,2,1), imagesc(I), colorbar, axis('square')
title('img'), xlabel('x'), ylabel('y')

subplot(3,2,2), imagesc(fx,fy,Ichapmod.^.5), colorbar, axis('square')
title('|TF(img)|^{0.5}'), xlabel('f_x'), ylabel('f_y')

hchap=ones(dimx,dimy);
hchap(dimx/2+1-rr:dimx/2+1+rr,dimy/2+1-rr:dimy/2+1+rr)=1.-hh;

subplot(3,2,4), imagesc(fx,fy,hchap), colorbar, axis('square')
title('|TF(passe-haut circ.)|'), xlabel('f_x'), ylabel('f_y')

hchap=fftshift(hchap);

Ichapfilt=hchap.*Ichap;
Ichapfiltmod=abs(fftshift(Ichapfilt));

subplot(3,2,6),imagesc(fx,fy,Ichapfiltmod.^.1), colorbar, axis('square')
title('|TF(img filt.)|^{0.1}'), xlabel('f_x'), ylabel('f_y')

Ifilt=ifft2(Ichapfilt);
subplot(3,2,5), imagesc(real(Ifilt)), colorbar, axis('square')
title('img filtre'), xlabel('x'), ylabel('y')

% filtrage passe-bande circulaire
figure(3), colormap('gray')

subplot(3,2,1), imagesc(I), colorbar, axis('square')
title('img'), xlabel('x'), ylabel('y')

subplot(3,2,2), imagesc(fx,fy,Ichapmod.^.1), colorbar, axis('square')
title('|TF(img)|^{0.5}'), xlabel('f_x'), ylabel('f_y')

hchap=zeros(dimx,dimy);
rrr=30; hhh=fspecial('disk',rrr); hhh=hhh/max(max(hhh));
hchap(dimx/2+1-rrr:dimx/2+1+rrr,dimy/2+1-rrr:dimy/2+1+rrr)=hhh;
hchap(dimx/2+1-rr:dimx/2+1+rr,dimy/2+1-rr:dimy/2+1+rr)=hchap(dimx/2+1-rr:dimx/2+1+rr,dimy/2+1-rr:dimy/2+1+rr)-hh;

subplot(3,2,4), imagesc(fx,fy,hchap), colorbar, axis('square')
title('|TF(passe-bande circ.)|'), xlabel('f_x'), ylabel('f_y')

hchap=fftshift(hchap);

Ichapfilt=hchap.*Ichap;
Ichapfiltmod=abs(fftshift(Ichapfilt));
subplot(3,2,6),imagesc(fx,fy,Ichapfiltmod.^.1), colorbar, axis('square')
title('|TF(img filt.)|^{0.1}'), xlabel('f_x'), ylabel('f_y')

Ifilt=ifft2(Ichapfilt);
subplot(3,2,5), imagesc(real(Ifilt)), colorbar, axis('square')
title('img filtre'), xlabel('x'), ylabel('y')

% filtrage coupe-bande circulaire
figure(4), colormap('gray')

subplot(3,2,1), imagesc(I), colorbar, axis('square')
title('img'), xlabel('x'), ylabel('y')

subplot(3,2,2), imagesc(fx,fy,Ichapmod.^.1), colorbar, axis('square')
title('|TF(img)|^{0.5}'), xlabel('f_x'), ylabel('f_y')

hchap=zeros(dimx,dimy);
hchap(dimx/2+1-rrr:dimx/2+1+rrr,dimy/2+1-rrr:dimy/2+1+rrr)=hhh;
hchap(dimx/2+1-rr:dimx/2+1+rr,dimy/2+1-rr:dimy/2+1+rr)=hchap(dimx/2+1-rr:dimx/2+1+rr,dimy/2+1-rr:dimy/2+1+rr)-hh;
hchap=1.-hchap;

subplot(3,2,4), imagesc(fx,fy,hchap), colorbar, axis('square')
title('|TF(coupe-bande circ.)|'), xlabel('f_x'), ylabel('f_y')

hchap=fftshift(hchap);

Ichapfilt=hchap.*Ichap;
Ichapfiltmod=abs(fftshift(Ichapfilt));
subplot(3,2,6),imagesc(fx,fy,Ichapfiltmod.^.1), colorbar, axis('square')
title('|TF(img filt.)|^{0.1}'), xlabel('f_x'), ylabel('f_y')

Ifilt=ifft2(Ichapfilt);
subplot(3,2,5), imagesc(real(Ifilt)), colorbar, axis('square')
title('img filtre'), xlabel('x'), ylabel('y')