%%% (0) PRELIMINAIRES

%%% prliminaires
clear
close all

%%% prparation image
img=imread('/Users/marcel/Documents/MATLAB/0-images-exemples/bird.jpg');
img=rgb2gray(img); img=double(img)/255.;
dim=size(img); dim=dim(1);      % mme dim en x et en y ici (256)
fx=((0:dim-1)-dim/2)/dim; fy=fx;

%%% FFT(image) - pour comparaison
img_chap = fftshift(fft2(img)); % on se place dans un plan de Fourier
                                % cette fois-ci r-ordonn !
                                
%%% (2) DETRAMAGE

%%% tramage
Tx=12.8;                       % Tx=12.8px
                               % => fc=1/Tx*dim=256/12.8=20px^-1   
x=0:(dim-1); coeff=.2;
tram=ones(dim,1)*cos(2*pi*x/Tx)*coeff;
imgt=img+tram;
imgt_chap = fftshift(fft2(imgt));

%%% filtrage coupe-frquel (dtramage)
imgt_chap_filt=imgt_chap;
fc = dim/Tx;
imgt_chap_filt(dim/2+1,dim/2+1+fc)=0.;
imgt_chap_filt(dim/2+1,dim/2+1-fc)=0.;
imgt_filt=ifft2(ifftshift(imgt_chap_filt)); %  cause du r-ordonnage
                                            % dans le plan de Fourier,
                                            % on est oblig d'utiliser
                                            % ifftshift avant de faire
                                            % la FFT inverse

%%% rsultat tramage/dtramage
figure, colormap('gray')

subplot(3,2,1)
imagesc(img), colorbar, axis('square')
title('original img'), xlabel('x'), ylabel('y')

subplot(3,2,2)
imagesc(fx,fy,abs(img_chap).^.1), colorbar, axis('square')
title('|FFT(img)|^{0.1}'), xlabel('f_x'), ylabel('f_y')

subplot(3,2,3)
imagesc(imgt), colorbar, axis('square')
title('img tramee'), xlabel('x'), ylabel('y')

subplot(3,2,4)
imagesc(fx,fy,abs(imgt_chap).^.1), colorbar, axis('square')
title('|FFT(img tramee)|^{0.1}'), xlabel('f_x'), ylabel('f_y')

subplot(3,2,5)
imagesc(real(imgt_filt)), colorbar, axis('square')
title('filtered img'), xlabel('x'), ylabel('y')

subplot(3,2,6)
imagesc(fx,fy,abs(imgt_chap_filt).^.1), colorbar, axis('square')
title('|FFT(filtered img)|^{0.1}'), xlabel('f_x'), ylabel('f_y')