clear
close all

dim=100; Dx=0.1;
x=0:Dx:(dim-1)*Dx; y=x;
whos x

Tx=2;
I=ones(dim,1)*(1+cos(2*pi*x/Tx));
whos I

Ichap=fft2(I);
whos Ichap
Ichapmod=abs(fftshift(Ichap));
whos Ichapmod

fx=1/(dim*Dx)*(-dim/2:dim/2-1);
fy=fx;

figure(1), colormap('gray')

subplot(3,2,1), imagesc(x,y, I), colorbar, axis('square')
title('Sinusode(x,y)'), xlabel('x'), ylabel('y')

subplot(3,2,2), imagesc(fx,fy,Ichapmod), colorbar, axis('square')
title('|FFT(Sinusode)|(f_x,f_y)'), xlabel('f_x'), ylabel('f_y')

subplot(3,2,3), plot(x,I(dim/2+1,:)), axis('square')
title('Sinusode(x)'), xlabel('x'), ylabel('sin(2*pi*x/Tx)')

subplot(3,2,4), plot(fx,Ichapmod(dim/2+1,:)), axis('square')
title('|FFT(Sinusode)|(f_x,f_y=0)')
xlabel('f_x'), ylabel('units arbitraires')

subplot(3,2,5), plot(y,I(:,dim/2+1)), axis('square')
title('Sinusode(y)'), xlabel('y'), ylabel('constante')

subplot(3,2,6), plot(fy,Ichapmod(:,dim/2+1)), axis('square')
title('|FFT(Sinusode)|(fx=0,fy)')
xlabel('f_y'), ylabel('units arbitraires')

dec=0.75;
Idec=ones(dim,1)*(1+cos(2*pi*(x-dec)/Tx));
Idecchap=fft2(Idec);
Idecchapmod=abs(fftshift(Idecchap));

figure(2), colormap('gray')

subplot(3,2,1), imagesc(x,y,Idec), colorbar, axis('square')
title('Sinusode dc. (x,y)'), xlabel('x'), ylabel('y')

subplot(3,2,2), imagesc(fx,fy,Idecchapmod), axis('square'), colorbar
title('|FFT(Sinusode dc.)|(f_x,f_y)'), xlabel('f_x'), ylabel('f_y')

subplot(3,2,3), plot(x,Idec(dim/2+1,:)), axis('square')
title('Sinusode dc. (x)'), xlabel('x'), ylabel('sin(2*pi*(x-dec)/Tx)')

subplot(3,2,4), plot(fx,Idecchapmod(dim/2+1,:)), axis('square')
title('|FFT(Sinusode dc.)(f_x,f_y=0)|')
xlabel('f_x'), ylabel('units arbitraires')

subplot(3,2,5), plot(y,Idec(:,dim/2+1)), axis('square')
title('Sinusode dc. (y)'), xlabel('y'), ylabel('constante')

subplot(3,2,6), plot(fy,Ichapmod(:,dim/2+1)), axis('square')
title('|FFT(Sinusode dc.)|(f_x=0,f_y)')
xlabel('f_y'), ylabel('units arbitraires')