clear
close all

% image
dim=128; I=zeros(dim,dim); I(:,1:dim/2)=0.6;
fx=((0:dim-1)-dim/2)/dim; fy=fx;

figure, colormap('gray')

subplot(3,3,1), imagesc(I), colorbar, axis('square')
title('img'), xlabel('x'), ylabel('y')

subplot(3,3,2), plot(I(64,:),'.'), axis('square')
xlim([2,dim-2]), ylim([-.1 .7]), title('coupe(img)'), xlabel('x')

% FFT(image)
Ichap=fft2(I);
Ichapmod=abs(fftshift(Ichap));
subplot(3,3,3), imagesc(fx,fy,Ichapmod.^.5), colorbar, axis('square')
title('|TF(img)|^{0.5}'), xlabel('f_x'), ylabel('f_y')

% "filtre"
hchap=zeros(dim,dim);
hchap(dim/4+1:3*dim/4,dim/4+1:3*dim/4)=1.;

subplot(3,3,6), imagesc(fx,fy,hchap), colorbar, axis('square')
title('hchap passe-bas'), xlabel('f_x'), ylabel('f_y')

hchap=fftshift(hchap);

% filtrage dans l'espace de Fourier
Ichapfilt=hchap.*Ichap;
Ichapfiltmod=abs(fftshift(Ichapfilt));
subplot(3,3,9), imagesc(fx,fy,Ichapfiltmod.^.5), colorbar, axis('square')
title('|TF(img filt.)|^{0.5}'), xlabel('f_x'), ylabel('f_y')

% retour dans l'espace rel
Ifilt=ifft2(Ichapfilt);
subplot(3,3,7), imagesc(real(Ifilt)), colorbar, axis('square')
title('img filt.'), xlabel('x'), ylabel('y')
subplot(3,3,8), plot(real(Ifilt(64,:)),'.'), axis('square')
title('coupe(img filt.)'), xlim([2,dim-2]), xlabel('x')